"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _forEach2 = _interopRequireDefault(require("lodash/forEach"));

var _utils = require("./utils");

var _nullField = _interopRequireDefault(require("./nullField"));

var _types = require("./types");

var ObjectField =
/*#__PURE__*/
function () {
  function ObjectField(_ref) {
    var rootSchema = _ref.rootSchema,
        schema = _ref.schema,
        key = _ref.key,
        isEntity = _ref.isEntity;
    (0, _classCallCheck2.default)(this, ObjectField);
    (0, _defineProperty2.default)(this, "schema", void 0);
    (0, _defineProperty2.default)(this, "rootSchema", void 0);
    (0, _defineProperty2.default)(this, "key", void 0);
    (0, _defineProperty2.default)(this, "isEntity", void 0);
    this.key = key;
    this.rootSchema = rootSchema;
    this.schema = schema;
    this.isEntity = isEntity || false;
  }

  (0, _createClass2.default)(ObjectField, [{
    key: "getKey",
    value: function getKey() {
      return this.key;
    }
  }, {
    key: "exists",
    value: function exists() {
      return true;
    }
  }, {
    key: "getType",
    value: function getType() {
      return _types.types.OBJECT;
    }
  }, {
    key: "getChild",
    value: function getChild(fieldName) {
      if (!this.schema.items || !this.schema.items[fieldName]) {
        return new _nullField.default({
          key: fieldName
        });
      }

      var field = (0, _utils.createField)(fieldName, this.rootSchema, this.schema.items[fieldName]);
      return field;
    }
  }, {
    key: "forEach",
    value: function forEach(visitor) {
      var _this = this;

      if (!this.schema || !this.schema.items) {
        return;
      }

      (0, _forEach2.default)(this.schema.items, function (item, key) {
        var field = (0, _utils.createField)(key, _this.rootSchema, _this.schema.items[key]);
        visitor(field);
      });
    }
  }]);
  return ObjectField;
}();

exports.default = ObjectField;